// T50ctrlMinVar.sce
// Minimum variance control
// ------------------------------------------
exec('ScIntro.sce',-1), mode(0)

nd=200;
b0=1.2; a1=.3; b1=-0.5; k=-3;                 // model parameters
th=[a1 b1 k]';
y(1)=3; y(2)=-1; u=ones(1,2);                // initial data
s=1*[ones(1,nd/2) -2*ones(1,nd/2)];          // setpoint
thE=rand(3,1,'n'); b0E=rand(1,1,'n');        // initial parameters
V=1e-8*eye(5,5);
for t=3:nd
  ps=[y(t-1) u(t-1) 1]'; 
  select 1
  case 1, u(t)=1/b0*(s(t)-th'*ps);           // known parameters
  case 2, u(t)=1/b0E*(s(t)-thE'*ps);         // estimated parameters
  end
  
  y(t)=b0*u(t)+th'*ps+.1*rand(1,1,'u');      // system
  
  // estimation
  Ps=[y(t) u(t) ps']';
  V=V+Ps*Ps';
  Vyp=V(2:5,1);
  Vp=V(2:5,2:5);
  P=inv(Vp)*Vyp;
  b0E=P(1);
  thE=P(2:4);
end

plot(1:nd,y,1:nd,s)
legend('y','s');
set(gca(),'data_bounds',[1 nd -3 3]);

b0E, thE
