function f=filts(x,n,na,nb,nc)
  // f=filts(x,n,na,nb,nc)
  // signal filtration (smoothing) by 3rd order splines
  // x   signal
  // n   length of polynomial
  // na  number of fictitious data for contiunity 
  // nb  number of fictitious data for for smooth 
  //     connecting (1st derivative)
  // nc  number of fictitious data for overal 
  //     smoothness (2nd derivative)
  //
  b=(x(2)-x(1))/n;
  a=x(1)+b;                   // leftmost initial condition
  nn=fix(max(size(x))/n);     // number of polynomials
  f=[];
  for i=1:nn                  // loop over polynomials
    ii=(1:n)+(i-1)*n;         // time points of single polynomial
    f=[f filt3(x(ii),a,na,b,nb,nc)]; // new polynomial
    b=(f($)-f($-1))/n;        // condition for smotthness
    a=f($)+b;                 // condition for continuity
  end
  if max(size(x))>max(size(f)) // last piece of the spline
    f=[f filt3(x((max(size(f))+1):$),a,na,b,nb,nc)]; 
  end
endfunction
